// DFT.H Defines DFTobject class
// version 1.0
// (c) 2005 Chad Berchek

#ifndef DFT_H
#define DFT_H

#include "wavetypes.h"
using namespace std;

class DFTobject {
	public:
		DFTobject(const sampleT* dataPtr = 0);
		void setFreq(frequencyT freq);
		void setLen(sampleCountT n);
		void setSamplingRate(samplingRateT samplingRate);
		void setFreqAndLen(frequencyT freq, sampleCountT len);
		void setNewData(const sampleT* dataPtr);
		
		amplitudeT getDualDftAmplitude();
		phaseT getDualDftPhase();
		amplitudeT getRawAmplitude();
		phaseT getRawPhase();
		amplitudeT getIdealAmplitude();
		phaseT getIdealPhase();
		
	private:
		frequencyT frequency;
		sampleCountT len;
		const sampleT* sampleData;
		samplingRateT samplingRate;
	
		struct DFTstate {
			amplitudeT amplitude;
			phaseT phase;
			bool isCurrent;
		};
	
		DFTstate ideal;
		DFTstate raw;
		DFTstate dual;
		
		void invalidate();
		void Dft();
		void DualDft();
		void IdealDft();
};

#endif

